// Wild Magic Source Code
// David Eberly
// http://www.geometrictools.com
// Copyright (c) 1998-2007
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or (at
// your option) any later version.  The license is available for reading at
// either of the locations:
//     http://www.gnu.org/copyleft/lgpl.html
//     http://www.geometrictools.com/License/WildMagicLicense.pdf
//
// Version: 4.0.0 (2006/06/28)

#ifndef WTEXTURETREE_H
#define WTEXTURETREE_H

#include "Wm4TextureEffect.h"

class WTextureTree
{
public:
    WTextureTree ();

    void SetEffect (Wm4::TextureEffect* pkEffect);
    Wm4::TextureEffectPtr GetEffect ();
    void SetChildQuantity (int iQuantity);
    int GetChildQuantity () const;
    WTextureTree& GetChild (int i);

private:
    Wm4::TextureEffectPtr m_spkEffect;
    std::vector<WTextureTree> m_kChild;
};

#endif
